class Singleton(type):

    _instances = {}

    def __call__(cls, *args, **kwargs):
        if cls not in cls._instances:
            cls._instances[cls] = super(Singleton, cls).__call__(*args, **kwargs)
        return cls._instances[cls]
    
class MyClass(metaclass = Singleton):
    pass

s1 = MyClass()
s2 = MyClass()
print(id(s1))
print(id(s2))